package jalview.analysis;

import static org.junit.Assert.assertTrue;

import org.junit.Test;

import jalview.datamodel.Alignment;
import jalview.datamodel.AlignmentI;
import jalview.datamodel.Sequence;
import jalview.datamodel.SequenceI;
import jalview.io.AppletFormatAdapter;

public class AlignmentUtilsTests 
{
  public static Sequence ts=new Sequence("short","ASDASDASDASDASDASDASDASDASDASDASDASDASD");
  @Test
  public void testExpandFlanks()
  {
    AlignmentI al = new Alignment(new Sequence[] {});
    for (int i=4;i<14;i+=3)
    {
      SequenceI s1=ts.deriveSequence().getSubSequence(i, i+7);
      al.addSequence(s1);
    }
    System.out.println(new AppletFormatAdapter().formatSequences("Clustal", al, true));
    for (int flnk=-1;flnk<25; flnk++)
    {
      AlignmentI exp;
      System.out.println("\nFlank size: "+flnk);
      System.out.println(new AppletFormatAdapter().formatSequences("Clustal", exp=AlignmentUtils.expandContext(al, flnk), true));
      if (flnk==-1) {
        for (SequenceI sq:exp.getSequences())
      {
          String ung = sq.getSequenceAsString().replaceAll("-+", "");
          assertTrue("Flanking sequence not the same as original dataset sequence.\n"+ung+"\n"+sq.getDatasetSequence().getSequenceAsString(),ung.equalsIgnoreCase(sq.getDatasetSequence().getSequenceAsString()));
      }
      }
    }    
  }
}
